;================================================
;	ROCKET SLIDER E500
;	ver 1.00
;	for XASM 1.3x/1.4x
;	2006.04-
;	by choikyun
;================================================



	org	0be700h
	scope_on
	pre_off
	include DEF.INC
	include	DEFGAME.S



;================================================
;	CODE
;================================================
Start:
	pushu	imr

	pre	32h
	mv	[--u],(0ech)
	pre	32h
	mv	(0ech),0

	mv	(save_sp),s		;X^bN|C^ۑ

	mv	il,4
	sbcl	(bx),(bx)
	mv	a,[(0e6h)+8]
	mv	il,048h
	call	IocsCall		;\JnCZbg
	call	Cls
	call	Credit			;҃NWbg

	;^C}ݒ
	mvp	(save_fast),[0bfcc6h]	;t@[Xg^C}ۑ
	mv	x,Timer
	mv	[0bfcc6h],x
	or	(0fdh),0000_0010b	;16ms

	mv	(f_start_flg),0
	mv	(0fbh),081h		;^C}荞݊Jn



	;e평
Init:
	mv	(level),0	;x
	mvp	(hiscore),[HiScoreBuf]
	mvp	(bestrap),[BestRapBuf]
	mvp	(score),0
	mvp	(val_rap),0	;XRAA^CZbg

	mv	(sound),1	;ʉ
	mv	(flash),ON
	call	DispStatus	;EXe[^XʍXV



	;ăX^[g
ReStart:
	call	InitValue
	call	InitBG		;wi
	call	Ready



	;C[`
Main:
 {
	call	Inkey			;L[ǂݏo

	call	AddScreen		;XN[
	call	DispSlider		;XC_[\
	call	MoveSlider		;XC_[ړF㉺
	call	DispItem		;ACe\
	call	CheckHitWall		;Ǔ蔻
	call	DispMeter		;\
	call	RapCount		;bvJEg
	call	DispRapTime		;bv^C\
	call	DispScreen		;XN[\

	call	Retire			;^C
	call	GameOver		;Q[I[o[

	test	(key),KEY_BASIC
	jrz	continue
 }



	;I
Basic:
	mv	s,(save_sp)		;X^bN|C^A
	and	[SCRN_CSR_Y],0		;sZbg

	mv	(0fbh),0
	mvp	[0bfcc6h],(save_fast)	;^C}荞ݕA
	or	(0fdh),0000_0010b	;16ms

	call	Cls
	call	VerInfo			;o[W\
	pre	32h
	mv	(0ech),[u++]
	popu	imr
	rc
	retf



;------------------------------------------------
;	eϐ
;------------------------------------------------
InitValue:
 {
	mvw	(slider_x),120*256+0	;(120,14)
	mvw	(slider_y),14*256+0

	mvw	(slider_vx),0		;X0
	mvw	(slider_vy),0		;Y0

	mvw	(speed_max),DEF_SPEED_MAX	;Xőx

	mv	(slider_wait),DEF_SLED_WAIT	;EFCgl

	mv	(scroll_flg),0		;XN[tO
	mv	(scroll_step),7		;XN[

	mv	(item_flg),0		;ACetO
;	mv	(bonus_flg),0		;{[iXACe
	mv	(boost_count),0

	mv	(roll_width),DEF_ROLL_WIDTH
	mv	(level_up_count),DEF_LEVEL_CNT


	mv	(goal_flg),0		;S[tO

	mvp	(val_rap),0		;bv^CZbg
	mv	(f_time_count),6	;JEg
	mv	(f_start_flg),0		;JEgX^[gtO
	mv	(f_rap_flg),0		;bvX^[gtO

	mvp	(score),000010h		;{_100000_
	ret
 }



;------------------------------------------------
;	Q[Jn
;------------------------------------------------
Ready:
 {
	{
		call	Inkey			;L[ǂݏo
		call	AddScreen		;XN[
		call	DispSlider		;XC_[ړ
		call	Print_PUSH		;bZ[W
		call	ChangeLevel		;xI short or large
		call	ChangeSE		;ʉ؂芷
		mv	(flash),ON
		call	DispStatus		;Xe[^XʍXV
		call	DispScreen		;XN[\

		test	(keyf),KEY_BASIC
		jrnz	Basic
		test	(keyf),KEY_SPACE
		jrz	continue
	}
	mv	(sound_no),1
	call	Se

	mv	(f_start_flg),1			;^C}JEgJn
 }



Print_PUSH:
 {
	mv	y,ScreenBuf
	mv	x,Mes_PUSH
	mv	il,90
	mv	ba,3*256+38	;(38,3)
	jp	PutPattn_SET
 }



	;Tu@R[XI SHORT/LONG
ChangeLevel:
 {
	{
		test	(keyf),KEY_8
		jrz	break
		xor	(level),1
		mv	(sound_no),1
		call	Se
	}
	{
		cmp	(level),0
		jrnz	break

		mvp	(hiscore),[HiScoreBuf]	;XRAA^C̃[h
		mvp	(bestrap),[BestRapBuf]

		mvw	(val_meter),0008h	;800m
		mv	x,Mes_SHORT
		mv	il,49
		mv	ba,0*256+8		;(8,0)
		jp	PutPattn_SET
	}
	mvp	(hiscore),[HiScoreBuf+3]
	mvp	(bestrap),[BestRapBuf+3]

	mvw	(val_meter),0012h		;1200m
	mv	x,Mes_LARGE
	mv	il,49
	mv	ba,0*256+8
	jp	PutPattn_SET
 }



;	ʉ؂芷
ChangeSe:
 {
	{
		test	(keyf),KEY_CCE
		jrz	break

		xor	(sound),1

		mv	(sound_no),1
		call	Se

		mv	x,Icon_Se
		mv	a,(sound)
		swap	a
		ror	a
		add	x,a
		mv	y,Bg_STATUS+SCREEN_WIDTH*3+113
		mv	il,7
		mvl	(work),[x+0]
		mv	il,7
		mvl	[y+0],(work)
		mv	(flash),ON
	}
	ret
 }



;------------------------------------------------
;	^C
;------------------------------------------------
Retire:
 {
	{
		test	(keyf),KEY_6
		jrnz	break
		ret
	}
	mv	(sound_no),1
	call	Se
	{
		call	Inkey
		call	AddScreen		;XN[
		call	DispSlider		;XC_[\
		call	Print_RETIRE		;bZ[W
		call	Print_PUSH		;bZ[W
		call	DispScreen		;XN[\

		test	(keyf),KEY_BASIC
		jpnz	Basic
		test	(keyf),KEY_SPACE
		jrz	continue
	}
	call	Se
	pops	i
	jp	ReStart
 }



	;Tu	bZ[W\
Print_RETIRE:
 {
	mv	y,ScreenBuf
	mv	x,Mes_RETIRE
	mv	il,41
	mv	ba,1*256+48	;(58,1)
	jp	PutPattn_SET
 }



;------------------------------------------------
;	[XI
;------------------------------------------------
GameOver:
 {
	{
		test	(goal_flg),FLG_CLEAR
		jrnz	break
		ret
	}
;	mv	(flash),ON	;Xe[^XʍXV
;	call	DispStatus

	mv	(sound_no),1
	call	Se
	call	Se
	{
		call	Inkey			;L[ǂݏo
		call	DispSlider		;XC_[ړ
		call	Print_GOAL		;bZ[W
		call	Print_PUSH		;bZ[W
		call	DispMeter		;
		call	Print_SCORE		;XRA\
		call	DispScreen		;XN[\

		test	(keyf),KEY_BASIC
		jpnz	Basic
		test	(keyf),KEY_SPACE
		jrz	continue
	}
	call	CmpTime
	call	CmpScore
	mv	(sound_no),1
	call	Se
	pops	i
	jp	ReStart
 }



	;Tu	bZ[W\
Print_GOAL:
 {
	mv	y,ScreenBuf
	mv	x,Mes_GOAL
	mv	il,49
	mv	ba,1*256+44	;(44,0)
	jp	PutPattn_SET
 }



;------------------------------------------------
;	XC_[ړ
;------------------------------------------------
MoveSlider:
 {
	{
		dec	(slider_wait)
		jrz	break
		ret
	}
	mv	(slider_wait),DEF_SLED_WAIT
	call	CheckHitItem			;ACe蔻
	call	Booster				;

	mvp	(vwork),210300h			;-321
	call	SubScore			;XRAZ

	mv	a,ACC_VY
	mv	(sound_no),0
	{
		test	(key),KEY_8		;ړ
		jrz	break
		mv	il,2
		sbcl	(slider_vy),a
;		mvp	(vwork),010000h		;-1
;		call	SubScore
	}
	{
		test	(key),KEY_2		;ړ
		jrz	break
		mv	il,2
		adcl	(slider_vy),a
;		mvp	(vwork),010000h		;-1
;		call	SubScore
	}
	call	AddVY
	jp	ScrollBG			;Oi^wiXN[
;	ret
 }



	;Tu@xZ
AddVY:
 {
	mv	il,2
	adcl	(slider_y),(slider_vy)		;YxZ

	call	AddRoll				;YhꕝZ
	{
		test	(slider_y+1),1000_0000b
		jrz	break
		mvw	(slider_vy),0
		mvw	(slider_y),0100h
	}
	{
		cmp	(slider_y+1),31-4
		jrc	break
		mvw	(slider_vy),0
		mvw	(slider_y),(31-5)*256+0
	}
	ret
 }



	;Tu@hꕝZ
AddRoll:
 {
	mv	a,(roll_width)
	{
		call	Rnd
		and	(val_rnd),1
		jrz	break
		mv	il,2
		sbcl	(slider_vy),a
		ret
	}
	mv	il,2
	adcl	(slider_vy),a
	ret
 }



;------------------------------------------------
;	JEg
;------------------------------------------------
Booster:
 {
	{
		cmp	(boost_count),0
		jrz	break
		{
			dec	(boost_count)
			jrz	break
			call	SubMeter
			mvp	(vwork),001400h		;+1400
			call	AddScore
			mv	(roll_width),DEF_B_ROLL_WIDTH;hꕝ
			mv	(sound_no),2
			jp	Se
		}
		mvw	(speed_max),DEF_SPEED_MAX
		mvw	(slider_vx),(speed_max)
		mv	(roll_width),DEF_ROLL_WIDTH
		mvw	(slider_vy),0
	}
	ret
 }



;------------------------------------------------
;	wiXN[
;------------------------------------------------
ScrollBG:
 {

	{
		mv	ba,(speed_max)		;ōx
		cmpw	(slider_vx),ba
		jrnc	break
		mv	a,ACC_VX		;Xx
		mv	il,2
		adcl	(slider_vx),a
	}
	{
		cmp	(scroll_flg),0
		jrnz	break
		jp	AddVX
	}
	call	ScrollRight			;XN[
	{
		sub	(scroll_step),a
		jrnc	break
		mv	(scroll_step),7
		call	SubMeter		;c苗
		call	MakeNewWall		;VǍ쐬
	}
	ret
 }



;------------------------------------------------
;	BGEXN[
;------------------------------------------------
ScrollRight:
 {
	mv	a,(slider_vx+1)
	mv	x,FieldBuf+SCREEN_WIDTH*SCREEN_HEIGHT
	mv	y,x
	sub	x,a
	mv	(work),4
	{
		mv	il,32
		mvl	(work+33),[--x]
		mv	il,32
		mvl	[--y],(work+33)
		mv	il,32
		mvl	(work+33),[--x]
		mv	il,32
		mvl	[--y],(work+33)
		mv	il,32
		mvl	(work+33),[--x]
		mv	il,32
		mvl	[--y],(work+33)
		mv	il,32
		sub	il,a
		mvl	(work+33),[--x]
		mv	il,32
		sub	il,a
		mvl	[--y],(work+33)

		sub	y,a
		sub	x,a
		dec	(work)
		jrnz	continue
	}
	jp	ScrollItem		;ACeXN[
 }



;------------------------------------------------
;	xZ@X
;------------------------------------------------
AddVX:
 {
	{
		cmp	(goal_flg),0
		jrz	break
		{
			cmp	(slider_x+1),9
			jrnc	break
			or	(goal_flg),FLG_CLEAR	;[XI
			ret
		}
		mv	il,2
		sbcl	(slider_x),(slider_vx)
		ret
	}
	{
		cmp	(slider_x+1),START_SCROLL_X
		jrc	break
		mv	il,2
		sbcl	(slider_x),(slider_vx)
		ret
	}
	inc	(scroll_flg)	;XN[Jn
	ret
 }



;------------------------------------------------
;	R[XAEgăX^[g@˕Ԃ
;------------------------------------------------
MoveReturnPoint:
 {
	call	ReboundY
	call	ReboundX

	mvw	(slider_vx),0
	mv	(scroll_flg),0
	mvw	(speed_max),DEF_SPEED_MAX	;Zbg
	mv	(boost_count),0
	mv	(roll_width),DEF_ROLL_WIDTH	;hꕝZbg
	ret
 }



	;Tu@˕Ԃ
ReboundY:
 {
	{
		test	(slider_vy+1),1000_0000b
		jrz	break
		add	(slider_y+1),6
		mvw	(slider_vy),32
		ret
	}
	sub	(slider_y+1),6
	mvw	(slider_vy),-32
	ret
 }



ReboundX:
 {
	add	(slider_x+1),16
	{
		cmp	(goal_flg),0
		jrnz	break

		mv	il,2
		mvw	(vwork),0200h
		dadl	(val_meter+1),(vwork+1)
	}
	ret
 }



;------------------------------------------------
;	XC_[\
;------------------------------------------------
DispSlider:
 {
	mv	a,(slider_y+1)
	mv	b,a
	mv	a,(slider_x+1)
	{
		test	a,1000_0000b	;X␳
		jrz	break
		mv	a,0
	}
	mv	y,ScreenBuf
	mv	x,Chr_SLIDER
	call	PutChr
	{
		cmp	(boost_count),0
		jrz	break
		add	a,8
		mv	x,Chr_BOOST	;ΉԁiHj\
		call	PutChr
	}
	ret
 }



;------------------------------------------------
;	ACe̔
;------------------------------------------------
CheckHitItem:
 {
	{
		cmp	(item_flg),0
		jrnz	break
		ret
	}
	{
		mv	a,(slider_x+1)	;mx-ex+a<a+b+1
		sub	a,(item_x)
		add	a,7
		cmp	a,7+3+1
		jrc	break
		ret
	}
	{
		mv	a,(slider_y+1)	;my-ey+a<a+b+1
		sub	a,(item_y)
		add	a,3
		cmp	a,3+3+1
		jrc	break
		ret
	}
	mvp	(vwork),006000h		;+6000
	{
		cmp	(boost_count),0
		jrz	break
		mvp	(vwork),000001h	;+10000
	}
	call	AddScore
	mv	(item_flg),0

	add	(boost_count),DEF_BST_COUNT	;JEgZ
	mvw	(speed_max),DEF_BOOST_MAX-080h	;ő呬x
	mvw	(slider_vx),(speed_max)		;

	mv	(sound_no),1
	jp	Se
 }



;------------------------------------------------
;	ǂ̔
;------------------------------------------------
CheckHitWall:
 {
	mv	a,(slider_y+1)
	mv	b,a
	mv	a,(slider_x+1)
	mv	x,Chr_SLIDER
	mv	y,FieldBuf

	call	GetPosition

	mv	(_PX),work
	{
		mv	il,[x++]
		pre	36h
		mv	(0),i
		add	(_PX),2
		cmp	(_PX),work+2*CHR_SIZE
		jrnz	continue
	}
	{
		and	a,7
		jrz	break
		{
			mv	il,2*CHR_SIZE
			adcl	(work),(work)
			dec	a
			jrnz	continue
		}
	}
	mv	(_PX),work
	{
		mv	a,[y+SCREEN_WIDTH]
		pre	36h
		and	(1),a
		jrnz	break
		mv	a,[y]
		pre	36h
		and	(0),a
		jrnz	break

		add	(_PX),2
		cmp	(_PX),work+2*CHR_SIZE
		jrnz	continue
		ret
	}
	mvp	(vwork),008001h		;-18000
	call	SubScore
	mv	(sound_no),0
	call	Se
	jp	MoveReturnPoint		;ԂăX^[g
;	call	Print_OUT		;bZ[W\
;	call	DispScreen
;	mv	i,350
;	call	Wait

;	call	ReversVY		;x]
;	mv	il,2
;	adcl	(slider_y),(slider_vy)
;	mv	il,2
;	adcl	(slider_x),(slider_vx)
;	mv	(scroll_flg),0
;	ret
 }



	;Tu@bZ[W
;Print_OUT:
; {
;	mv	y,ScreenBuf+SCREEN_BLANK
;	mv	x,Mes_OUT
;	mv	il,57
;	mv	ba,1*256+31	;(31,1)
;	jp	PutPattn_SET
; }



;------------------------------------------------
;	ACeZbg
;------------------------------------------------
SetNewItem:
 {
	{
		cmp	(item_flg),0
		jrz	break
		ret
	}
	{
		mv	a,(course_h)
		sub	a,4
		jrnc	break
		mv	a,0
	}
	{
		call	Rnd
		and	(val_rnd),31
		cmp	(val_rnd),a
		jrnc	continue
	}
	inc	(item_flg)
	mv	a,(val_rnd)
	add	a,(course_y)
	inc	a

	mv	(item_x),0
	mv	(item_x+1),a

	ret
 }



;------------------------------------------------
;	{[iXACeZbg
;------------------------------------------------
;SetNewBonus:
; {
;	{
;		cmp	(bonus_flg),0
;		jrz	break
;		ret
;	}
;	{
;		call	Rnd
;		and	(val_rnd),31
;		jrz	break
;		ret
;	}
;	inc	(bonus_flg)
;	{
;		mv	a,(course_y)
;		inc	a
;		call	Rnd
;		and	(val_rnd),1
;		jrz	break
;		add	a,(course_h)
;		sub	a,9
;	}
;	mv	b,a
;	mv	a,0
;	mv	(bonus_x),ba
;	ret
; }



;------------------------------------------------
;	ACe\
;------------------------------------------------
DispItem:
 {
	{
		cmp	(item_flg),0
		jrnz	break
		ret
	}
	mv	ba,(item_x)

	mv	y,ScreenBuf
	mv	x,Chr_ITEM	;ACe
	jp	PutChr
;	{
;		cmp	(bonus_flg),0
;		jrnz	break
;		ret
;	}
;	mv	ba,(bonus_x)
;
;	mv	x,Chr_BONUS	;{[iXACe
;	jp	PutChr
 }



;------------------------------------------------
;	ACeXN[
;------------------------------------------------
ScrollItem:
 {
	{
		cmp	(item_flg),0
		jrnz	break
		ret
	}
	{
		mv	a,(slider_vx+1)		;ACe
		add	(item_x),a
		cmp	(item_x),128-3
		jrc	break
		dec	(item_flg)
	}
;	{
;		cmp	(bonus_flg),0
;		jrnz	break
;		ret
;	}
;	{
;		mv	a,(slider_vx+1)		;{[iXACe
;		add	(bonus_x),a
;		cmp	(bonus_x),128-8
;		jrc	break
;		dec	(bonus_flg)
;	}
	ret
 }



;------------------------------------------------
;	XN[obt@
;------------------------------------------------
AddScreen:
 {
	mv	x,ScreenBuf+SCREEN_BLANK
	mv	y,FieldBuf+SCREEN_BLANK
	mv	a,4
	{
		mv	il,32
		mvl	(work),[y++]
		mv	il,32
		mvl	[x++],(work)
		mv	il,32
		mvl	(work),[y++]
		mv	il,32
		mvl	[x++],(work)
		mv	il,32
		mvl	(work),[y++]
		mv	il,32
		mvl	[x++],(work)
		mv	il,32-SCREEN_BLANK/4
		mvl	(work),[y++]
		mv	il,32-SCREEN_BLANK/4
		mvl	[x++],(work)
		dec	a
		jrnz	continue
	}
	ret
 }



;------------------------------------------------
;	R[X쐬
;------------------------------------------------
InitBG:
 {
	mv	(course_w),1		;R[X1ubN̒@l
	mv	(course_h),28		;R[X@l

	call	Rnd
	and	(val_rnd),2
	dec	(val_rnd)
	mv	(course_add_y),(val_rnd);-1 or 1

	mv	(course_x),120		;Xl
	call	Rnd
	and	(val_rnd),1
	mv	(course_y),(val_rnd)	;Yl
	{
		call	MakeNewWall	;Ǎ쐬

		sub	(course_x),8
		jrnc	continue
	}
	mv	(course_x),0
	ret
 }



;------------------------------------------------
;	VǍ쐬
;	(course_w)	R[X1ubN̒
;	(course_h)	R[X
;	(course_x)	R[XX
;	(course_y)	R[XY
;	(course_add_y)	R[XY@-1 or 1
;------------------------------------------------
MakeNewWall:
 {
	pushu_reg
	call	ChangeCourseH			;R[XύX
	{
		dec	(course_w)
		jrnz	break

		call	Rnd
		and	(val_rnd),3
		inc	(val_rnd)
		mv	(course_w),(val_rnd)	;R[X1ubN̕

		call	ReversCourseY
		mv	a,(course_add_y)
		add	(course_y),a
		{
			test	(course_y),1000_0000b	;0<= y >=y_max
			jrz	break
			mv	(course_y),0
			call	ReversCourseY
		}
		{
			mv	a,(course_h)
			add	a,(course_y)
			cmp	a,31
			jrc	break
			dec	(course_y)
			call	ReversCourseY
		}
	}
	call	PutWall		;Ǖ`
	call	SetNewItem	;VACe
;	call	SetNewBonus	;V{[iXACe
	popu_reg
	ret
 }



	;Tu@܂Ԃ
ReversCourseY:
 {
	{
		call	Rnd
		and	(val_rnd),3
		jrnz	break
		xor	(course_add_y),0ffh
		inc	(course_add_y)
	}
	ret
 }



	;Tu@R[XύX
ChangeCourseH:
 {
	{
		dec	(level_up_count)
		jrz	break
		ret
	}
	mv	(level_up_count),DEF_LEVEL_CNT
	dec	(course_h)
	{
		cmp	(course_h),15
		jrnc	break
		inc	(course_h)
	}
	ret
 }



;------------------------------------------------
;	Ǖ`
;	(course_x)	XW
;	(course_y)	YW
;	(course_h)	
;------------------------------------------------
PutWall:
 {
	pushu_reg
	call	DrawBoxFill		;hԂ

	mv	y,FieldBuf
	mv	ba,(course_x)
	call	GetPosition

	and	a,7
	mv	(work),a

	mv	x,Chr_Wall
	swap	a
	ror	a
	add	x,a

	mv	il,8			;ǁ@
	mvl	(work+1),[x++]
	mv	il,8
	mvl	[y+0],(work+1)

	mv	a,(course_h)
	xor	(work),7
	sub	a,(work)

	mv	(work),(course_y)
	{
		cmp	a,8
		jrc	break
		sub	a,8

		mv	il,SCREEN_WIDTH
		add	y,il
		mv	x,Chr_BLANK	;󔒕`
		mv	il,8
		mvl	(work+1),[x++]
		mv	il,8
		mvl	[y+0],(work+1)
		jr	continue
	}
	mv	il,SCREEN_WIDTH
	add	y,il

	mv	x,Chr_WALL+64
	swap	a
	ror	a
	add	x,a

	mv	il,8			;ǉ
	mvl	(work+1),[x++]
	mv	il,8
	mvl	[y++],(work+1)

	popu_reg
	ret
 }



	;Tu@hԂ
DrawBoxFill:
 {
	mv	x,FieldBuf
	mv	a,(course_x)
	add	x,a
	mv	(work),4
	mv	a,0ffh
	{
		mv	il,8
		{
			mv	[x++],a
			dec	il
			jrnz	continue
		}
		mv	il,SCREEN_WIDTH-8
		add	x,il
		dec	(work)
		jrnz	continue
	}
	ret
 }




	include		VER.S		;o[W

	include		LIB.S		;ėpCu
	include		SCORE.S		;XRA

	include		DATA.S		;f[^
	include		WORK.S		;[N



	end
